/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */

// clang-format off
export {
  defineBase as ɵdefineBase,
  defineComponent as ɵdefineComponent,
  defineDirective as ɵdefineDirective,
  definePipe as ɵdefinePipe,
  defineNgModule as ɵdefineNgModule,
  detectChanges as ɵdetectChanges,
  renderComponent as ɵrenderComponent,
  ComponentType as ɵComponentType,
  ComponentFactory as ɵRender3ComponentFactory,
  ComponentRef as ɵRender3ComponentRef,
  DirectiveType as ɵDirectiveType,
  RenderFlags as ɵRenderFlags,
  directiveInject as ɵdirectiveInject,
  injectElementRef as ɵinjectElementRef,
  injectTemplateRef as ɵinjectTemplateRef,
  injectViewContainerRef as ɵinjectViewContainerRef,
  injectChangeDetectorRef as ɵinjectChangeDetectorRef,
  injectAttribute as ɵinjectAttribute,
  getFactoryOf as ɵgetFactoryOf,
  getInheritedFactory as ɵgetInheritedFactory,
  templateRefExtractor as ɵtemplateRefExtractor,
  PublicFeature as ɵPublicFeature,
  InheritDefinitionFeature as ɵInheritDefinitionFeature,
  NgOnChangesFeature as ɵNgOnChangesFeature,
  NgModuleType as ɵNgModuleType,
  NgModuleRef as ɵRender3NgModuleRef,
  CssSelectorList as ɵCssSelectorList,
  markDirty as ɵmarkDirty,
  NgModuleFactory as ɵNgModuleFactory,
  NO_CHANGE as ɵNO_CHANGE,
  container as ɵcontainer,
  nextContext as ɵnextContext,
  elementStart as ɵelementStart,
  namespaceHTML as ɵnamespaceHTML,
  namespaceMathML as ɵnamespaceMathML,
  namespaceSVG as ɵnamespaceSVG,
  element as ɵelement,
  listener as ɵlistener,
  text as ɵtext,
  embeddedViewStart as ɵembeddedViewStart,
  query as ɵquery,
  registerContentQuery as ɵregisterContentQuery,
  loadDirective as ɵloadDirective,
  projection as ɵprojection,
  bind as ɵbind,
  interpolation1 as ɵinterpolation1,
  interpolation2 as ɵinterpolation2,
  interpolation3 as ɵinterpolation3,
  interpolation4 as ɵinterpolation4,
  interpolation5 as ɵinterpolation5,
  interpolation6 as ɵinterpolation6,
  interpolation7 as ɵinterpolation7,
  interpolation8 as ɵinterpolation8,
  interpolationV as ɵinterpolationV,
  pipeBind1 as ɵpipeBind1,
  pipeBind2 as ɵpipeBind2,
  pipeBind3 as ɵpipeBind3,
  pipeBind4 as ɵpipeBind4,
  pipeBindV as ɵpipeBindV,
  pureFunction0 as ɵpureFunction0,
  pureFunction1 as ɵpureFunction1,
  pureFunction2 as ɵpureFunction2,
  pureFunction3 as ɵpureFunction3,
  pureFunction4 as ɵpureFunction4,
  pureFunction5 as ɵpureFunction5,
  pureFunction6 as ɵpureFunction6,
  pureFunction7 as ɵpureFunction7,
  pureFunction8 as ɵpureFunction8,
  pureFunctionV as ɵpureFunctionV,
  getCurrentView as ɵgetCurrentView,
  restoreView as ɵrestoreView,
  containerRefreshStart as ɵcontainerRefreshStart,
  containerRefreshEnd as ɵcontainerRefreshEnd,
  queryRefresh as ɵqueryRefresh,
  loadQueryList as ɵloadQueryList,
  elementEnd as ɵelementEnd,
  elementProperty as ɵelementProperty,
  projectionDef as ɵprojectionDef,
  reference as ɵreference,
  elementAttribute as ɵelementAttribute,
  elementStyling as ɵelementStyling,
  elementStylingMap as ɵelementStylingMap,
  elementStyleProp as ɵelementStylingProp,
  elementStylingApply as ɵelementStylingApply,
  elementClassProp as ɵelementClassProp,
  textBinding as ɵtextBinding,
  template as ɵtemplate,
  embeddedViewEnd as ɵembeddedViewEnd,
  store as ɵstore,
  load as ɵload,
  pipe as ɵpipe,
  BaseDef as ɵBaseDef,
  ComponentDef as ɵComponentDef,
  ComponentDefInternal as ɵComponentDefInternal,
  DirectiveDef as ɵDirectiveDef,
  PipeDef as ɵPipeDef,
  whenRendered as ɵwhenRendered,
  i18nApply as ɵi18nApply,
  i18nExpMapping as ɵi18nExpMapping,
  i18nInterpolation1 as ɵi18nInterpolation1,
  i18nInterpolation2 as ɵi18nInterpolation2,
  i18nInterpolation3 as ɵi18nInterpolation3,
  i18nInterpolation4 as ɵi18nInterpolation4,
  i18nInterpolation5 as ɵi18nInterpolation5,
  i18nInterpolation6 as ɵi18nInterpolation6,
  i18nInterpolation7 as ɵi18nInterpolation7,
  i18nInterpolation8 as ɵi18nInterpolation8,
  i18nInterpolationV as ɵi18nInterpolationV,
  i18nMapping as ɵi18nMapping,
  I18nInstruction as ɵI18nInstruction,
  I18nExpInstruction as ɵI18nExpInstruction,
  WRAP_RENDERER_FACTORY2 as ɵWRAP_RENDERER_FACTORY2,
} from './render3/index';

export {  Render3DebugRendererFactory2 as ɵRender3DebugRendererFactory2 } from './render3/debug';


export {
  compileNgModuleDefs as ɵcompileNgModuleDefs,
  patchComponentDefWithScope as ɵpatchComponentDefWithScope,
} from './render3/jit/module';

export {
  compileComponent as ɵcompileComponent,
  compileDirective as ɵcompileDirective,
} from './render3/jit/directive';

export {
  compilePipe as ɵcompilePipe,
} from './render3/jit/pipe';

export {
  NgModuleDef as ɵNgModuleDef,
  NgModuleDefInternal as ɵNgModuleDefInternal,
  NgModuleTransitiveScopes as ɵNgModuleTransitiveScopes,
} from './metadata/ng_module';

export {
  sanitizeHtml as ɵsanitizeHtml,
  sanitizeStyle as ɵsanitizeStyle,
  sanitizeUrl as ɵsanitizeUrl,
  sanitizeResourceUrl as ɵsanitizeResourceUrl,
} from './sanitization/sanitization';

export {
  bypassSanitizationTrustHtml as ɵbypassSanitizationTrustHtml,
  bypassSanitizationTrustStyle as ɵbypassSanitizationTrustStyle,
  bypassSanitizationTrustScript as ɵbypassSanitizationTrustScript,
  bypassSanitizationTrustUrl as ɵbypassSanitizationTrustUrl,
  bypassSanitizationTrustResourceUrl as ɵbypassSanitizationTrustResourceUrl,
} from './sanitization/bypass';

export {
  ElementContext as ɵElementContext,
  getElementContext as ɵgetElementContext
} from './render3/element_discovery';
// clang-format on
